#include <SoftwareSerial.h>
SoftwareSerial outSerial(9, 10); // RX, TX
 
long int sp[]           = {600, 1200, 2400, 4800, 9600, 14400, 19200, 28800, 38400, 56000, 57600, 115200, 128000, 256000};
byte readUid[6]         = {0xAB, 0xBA, 0x00, 0x10, 0x00, 0x10};
byte writeUid[11]         = {0xAB, 0xBA, 0x00, 0x11, 0x04, 0x01, 0x02, 0x03, 0x05, 0x10};
byte readId[6]          = {0xAB, 0xBA, 0x00, 0x15, 0x00, 0x15};
byte writeId[12]        = {0xAB, 0xBA, 0x00, 0x16, 0x05, 0x57, 0x5A, 0x16, 0x2C, 0x59, 0x2A};
byte writeId2[12]       = {0xAB, 0xBA, 0x00, 0x16, 0x05, 0x2E, 0x00, 0xB6, 0xA3, 0x02, 0x2A};
byte writeSec[36]       = {0xAB, 0xBA, 0x00, 0x13, 0x19, 0x00, 0x01, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,1,2,3,4,5,6,7,8,9,12,3,4,5,6,7,8};
byte writeSec1[36]       = {0xAB, 0xBA, 0x00, 0x13, 0x19, 0x00, 0x01, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
byte readAllSector[12]  = {0xAB, 0xBA, 0x17, 0x07, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x1A};
byte readSepSec[]       = {0xAB, 0xBA, 0x00, 0x12, 0x09, 0x00, 1, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x10};
byte respose[50]         = {0xAB, 0xBA, 0x00, 0x16, 0x05, 0x2E, 0x00, 0xB6, 0xA3, 0x02, 0x2A};
byte resposeSec[50]         = {0xAB, 0xBA, 0x00, 0x16, 0x05, 0x2E, 0x00, 0xB6, 0xA3, 0x02, 0x2A};
             int rtd;
             int lastLenght = 5;
             int lenSec = 15;
#define PinIO 8
 
void setup() {
  // put your setup code here, to run once:
  //Serial.begin(9600);
  Serial.begin(115200);
  //outSerial.begin(9600); //скорость обмена программного порта 
  outSerial.begin(115200);
  pinMode(PinIO, OUTPUT);      // устанавливаем режим работы вывода, как "выход"
  digitalWrite(PinIO, LOW);   // устанавливаем режим W26 (W34 - низкий уровень)
        Serial.println("Начинаем работу");
}
 
void loop()
{
  int rd = Serial.read();
  if (rd == '1')  {    sendComand(readUid, 6);  }
  if (rd == '2')  {    sendComand(readId, 6);  }
  if (rd == '3')  {    sendComand(readAllSector, 12);  }
  if (rd == '4')  {    vaitSec();  } 
  if (rd == '5')  {    printKey(respose);  } 
  if (rd == '6')  {    vaitKey();  }
  if (rd == '7')  {    writeKeyUID();  }
  if (rd == '8')  {    writeKeybase();  }
  //if (rd == '8')  {    writeSecBack();  }
  if (rd == '9')  {    vaitUID();  }
  if (rd == '0')  {    printSec(readSepSec);  } 
  //  oxrCheck(writeId);
  //  Serial.print(rtd,HEX);
  //respose[3] = 0;
  // readRespose();
}
 
void writeKeyUID()
{ 
  writeUid[5+writeUid[4]] = oxrCheck(writeUid);
  //writeId[10] = oxrCheck(writeId);
  printKey(writeUid);
  //Serial.print(writeUid[5+writeUid[4]], HEX);
  int ik=0;
  do
  {
    sendComand(writeUid, 6+writeUid[4]);
    delay(500);
    readRespose();
    printKey(respose);
    ik++;
  } while ((respose[3] != 0x81)&&(ik<5));
  if (respose[3] = 0x81)
    {Serial.print("Запись произведена ");}
  else
    {Serial.print("Запись невозможна ");}  
  printKey(respose);
}
 
void writeKeyID()
{ 
  writeId2[5+writeId2[4]] = oxrCheck(writeId2);
  //writeId[10] = oxrCheck(writeId);
  printKey(writeId2);
  Serial.print(writeId2[5+writeId2[4]], HEX);
  do
  {
    sendComand(writeId2, 6+writeId2[4]);
    delay(500);
    readRespose();
    printKey(respose);
    //delay(100);
  } while (respose[5] != 0x81);
  Serial.print(respose[4], HEX);
  printKey(respose);
}

//Проверка секторов
void writeKeybase()
{
  int is=0; 
  int i=0,ik=0, ir;
  Serial.println("Проверяем запись секторов");
  for (int ib=0; ib<64; ++ib)
  {
  if ((i++)>3) {i=1; is++;};
  ir=rSec(is, ib);
  if ((ir == 0x81)&&(ir > 0)) //чтение произведено
    {  
    if (i!=4)
    {
    for (int im=0; im<50; ++im) {resposeSec[im]=respose[im];}
    Serial.println("Производим пробную запись");
    writeSec[20]=0xFE; writeSec[21]=ib+1;
    ir=wSec(is, ib);
      {
      if (ir == 0x81) //Запись произведена
        {  
        ir=rSec(is, ib);
        Serial.println("Восстанавливаем запись");
        ik=7+16;
        for (int im=7; im<ik; ++im) {writeSec1[im+7]=resposeSec[im];}
        ir=wSec1(is, ib);
        ir=rSec(is, ib);
        }
      else
        {Serial.println("Записать не удалось");}  
      }
    }
    }
  else
    {Serial.println("Чтение не удалось");}  
  }
  Serial.println("Проверка секторов завершена");
}

//Восстановление секторов
void writeSecBack()
{
  int is=0; 
  int i=0,ik=0, ir;
  Serial.println("Восстанавливаем запись секторов");
  for (int ib=0; ib<64; ++ib)
  {
  if ((i++)>3) {i=1; is++;};
  ir=rSec(is, ib);
  if ((ir == 0x81)&&(ir > 0)) //чтение произведено
    {  
    if ((i!=4)&&(ib>0))    {    ir=wSec1(is, ib);    }
    }
  else
    {Serial.println("Чтение не удалось");}  
  }
  Serial.println("Восстановление секторов завершено");
}
 
void vaitKey()
{
  do
  {
    sendComand(readId, 6);
    delay(100);
    readRespose();
    //delay(100);
  } while (respose[3] != 0x81);
  printKey(respose);
}
 
void vaitUID()
{
  byte cs = oxrCheck(readUid);
  do
  {
    sendComand(readUid, 6);
    delay(100);
    readRespose();
    //delay(100);
  } while (respose[3] != 0x81);
  printKey(respose);
}
 
//Чтение секторов
void vaitSec()
{
  Serial.println("Начинаем чтение секторов");
  int is=0; 
  int i=0;
  for (int ib=0; ib<63; ++ib)
  {
  if (i++>3) {i=1; is++;};
  rSec(is, ib);
  }
  Serial.println("Завершили чтение секторов");
}
 
//Чтение сектора
int rSec(int is, int ib)
{
  int i=0;
  readSepSec[5] = is;
  readSepSec[6] = ib;
  readSepSec[5+readSepSec[4]] = oxrCheck(readSepSec);
  i=0;
  do
  {
    sendComand(readSepSec, 15);
    delay(100);
    readRespose();
    i++;
  } while ((respose[3] != 0x81)&&(i<5));
  Serial.print("Сектор ");  Serial.print(is, HEX); Serial.print(" ");
  Serial.print("Блок ");  Serial.print(ib, HEX); Serial.print(" ");
  if (respose[3] = 0x81)    {    printSec(respose);        }
  else  {Serial.println("Чтение не удалось");}  
  if (respose[3] = 0x81)    {if (respose[4] = 0)  {return 0;} else  {return 0x81; }      }
  else  {return 0x80;}  
}
 
//Запись сектора
int wSec(int is, int ib)
{
  writeSec[5] = is;
  writeSec[6] = ib;
  writeSec[5+writeSec[4]] = oxrCheck(writeSec);
    sendComand(writeSec, 6+writeSec[4]);
    delay(100);
    readRespose();
  return respose[3];  
}
 
//Восстановительная запись сектора
int wSec1(int is, int ib)
{
  writeSec1[5] = is;
  writeSec1[6] = ib;
  writeSec1[5+writeSec1[4]] = oxrCheck(writeSec1);
    sendComand(writeSec1, 6+writeSec1[4]);
    delay(100);
    readRespose();
  return respose[3];  
}
 
void cleanRespose()
{
  for (int r = 0; r < lastLenght; ++r)
  {
    respose[r] = 0;
  }
}
 
void printKey(byte rp[])
{
  Serial.print("KEY: ");
  for (int y = 0; y < (6+rp[4]); ++y)//вывод
  {
    Serial.print(rp[y], HEX);
    Serial.print(" ");
  }
  Serial.print(" Lenght: ");
  Serial.print(rp[4], HEX);
  Serial.println("");
}

void printSec(byte rp[])
{
  Serial.print("SEC: ");
  //for (int y = 0; y < (5+rp[4]+1); ++y)//вывод
  for (int y = 7; y < (5+rp[4]); ++y)//вывод
  {
    Serial.print(rp[y], HEX);
    Serial.print(" ");
  }
  //Serial.print(" Lenght: ");
  //Serial.print(rp[4], HEX);
  Serial.println("");
}
 
void readRespose()
{
  int check = 0;
  if (outSerial.available())
  {
    //Serial.print("Read: ");
    while (outSerial.available())
    {
      respose[check] = outSerial.read();
      //Serial.print(respose[check], HEX); Serial.print(" ");
      ++check;
      lastLenght = check;
    }
    //Serial.println("");
  }
}
 
void sendComand(byte s[], int lenght)
{
  //Serial.print("Send: ");
  for (int i = 0; i < lenght; ++i)
  {
    outSerial.write(s[i]);
    //Serial.print(s[i], HEX); Serial.print(" ");
    delay(10);
  }
  //Serial.println("");
}
 
byte oxrCheck(byte rr[])
{
  //byte yy;
  int yy=0;
  //Serial.print("Check: ");
  for (int i = 2; i <= (4+rr[4]); ++i)
  {
    yy = yy ^ rr[i];
    //Serial.print(rr[i], HEX); Serial.print("-");
    //Serial.print(yy, HEX); Serial.print(" ");
  }
  //Serial.println("");
  return yy;
}
